Loading...
Searching...
No Matches
Sip_request

## Data Structures

struct | sip_request_s
| Structure for SIP request line. More...

## Macros

#define | sip_request(sip)
| Access a SIP request line structure sip_request_t from sip_t.
#define | SIP_REQUEST_INIT()
| Initializer for structure sip_request_t.
#define | SIPTAG_REQUEST(x)
| Tag list item for pointer to a request line structure sip_request_t.
#define | SIPTAG_REQUEST_REF(x)
| Tag list item for reference to a request line pointer.
#define | SIPTAG_REQUEST_STR(s)
| Tag list item for string with request line value.
#define | SIPTAG_REQUEST_STR_REF(x)
| Tag list item for reference to a request line string.

## Typedefs

typedef struct sip_request_s | sip_request_t
| @

## Functions

issize_t | sip_request_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP request line.
issize_t | sip_request_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP request line.
sip_request_t * | sip_request_init (sip_request_t x[1])
| Initialize a structure sip_request_t.
int | sip_is_request (sip_header_t const *header)
| Test if header object is instance of sip_request_t.
sip_request_t * | sip_request_dup (su_home_t *home, sip_request_t const *hdr))
| Duplicate a list of request line header structures sip_request_t.
sip_request_t * | sip_request_copy (su_home_t *home, sip_request_t const *hdr))
| Copy a list of request line header structures sip_request_t.
sip_request_t * | sip_request_make (su_home_t *home, char const *s))
| Make a request line structure sip_request_t.
sip_request_t * | sip_request_format (su_home_t *home, char const *fmt,...)))
| Make a request line from formatting result.
sip_request_t * | sip_request_create (su_home_t *home, sip_method_t method, char const *name, url_string_t const *uri, char const *version)
| Create a request line object.

## Variables

msg_hclass_t | sip_request_class []
| Header class for request line.
tag_typedef_t | siptag_request
| Tag for request line object.
tag_typedef_t | siptag_request_str
| Tag for string with request line value.

## Detailed Description

## Macro Definition Documentation

## SIP_REQUEST_INIT

#define SIP_REQUEST_INIT | ( |  | ) |

Initializer for structure sip_request_t.

A static sip_request_t structure for request line must be initialized with the SIP_REQUEST_INIT() macro. For instance,

sip_request_t sip_request = SIP_REQUEST_INIT;
sip_request
#define sip_request(sip)
Access a SIP request line structure sip_request_t from sip_t.
Definition sip_protos.h:131
SIP_REQUEST_INIT
#define SIP_REQUEST_INIT()
Initializer for structure sip_request_t.
Definition sip_protos.h:148
sip_request_t
struct sip_request_s sip_request_t
@
Definition sip.h:132

## SIPTAG_REQUEST

#define SIPTAG_REQUEST | ( |  | x | ) |

Tag list item for pointer to a request line structure sip_request_t.

The SIPTAG_REQUEST() macro is used to include a tag item with a pointer to a sip_request_t structure in a tag list.

Parameters

  x | pointer to a sip_request_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_REQUEST_REF().

## SIPTAG_REQUEST_STR

#define SIPTAG_REQUEST_STR | ( |  | s | ) |

Tag list item for string with request line value.

The SIPTAG_REQUEST_STR() macro is used to include a tag item with a string containing value of a sip_request_t header in a tag list.

Parameters

  s | pointer to a string containing request line value, or NULL.

The string in SIPTAG_REQUEST_STR() can be converted to a sip_request_t header structure by giving the string s has second argument to function sip_request_make().

The corresponding tag taking reference parameter is SIPTAG_REQUEST_STR_REF().

## Typedef Documentation

## sip_request_t

typedef struct sip_request_s sip_request_t

@

The request line is first line in a SIP request message. Its syntax defined in RFC 3261 as follows:

Request-Line = Method SP Request-URI SP SIP-Version CRLF
Request-URI = SIP-URI / SIPS-URI / absoluteURI
absoluteURI = scheme ":" ( hier-part / opaque-part )
hier-part = ( net-path / abs-path ) [ "?" query ]
net-path = "//" authority [ abs-path ]
abs-path = "/" path-segments
opaque-part = uric-no-slash *uric
uric = reserved / unreserved / escaped
uric-no-slash = unreserved / escaped / ";" / "?" / ":" / "@"
/ "&" / "=" / "+" / "$" / ","
path-segments = segment *( "/" segment )
segment = *pchar *( ";" param )
param = *pchar
pchar = unreserved / escaped /
":" / "@" / "&" / "=" / "+" / "$" / ","
scheme = ALPHA *( ALPHA / DIGIT / "+" / "-" / "." )
authority = srvr / reg-name
srvr = [ [ userinfo "@" ] hostport ]
reg-name = 1*( unreserved / escaped / "$" / ","
/ ";" / ":" / "@" / "&" / "=" / "+" )
query = *uric
SIP-Version = "SIP" "/" 1*DIGIT "." 1*DIGIT
CRLF
#define CRLF
DIGIT
#define DIGIT
SP
#define SP
ALPHA
#define ALPHA

The parsed request-line is stored in sip_request_t structure.

The structure sip_request_t contains representation of SIP request line.

The sip_request_t is defined as follows:

typedef struct sip_request_s {
sip_common_t rq_common[1]; // Common fragment info
sip_unknown_t *rq_next; // Link to next (dummy)
sip_method_t rq_method; // Method enum
char const *rq_method_name; // Method name
url_t rq_url[1]; // RequestURI
char const *rq_version; // Protocol version
} sip_request_t;
sip_unknown_t
msg_unknown_t sip_unknown_t
@
Definition sip.h:135
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_method_t
sip_method_t
IDs for well-known SIP methods.
Definition sip.h:48
sip_request_s
Structure for SIP request line.
Definition sip.h:357
sip_request_s::rq_method
sip_method_t rq_method
Method enum.
Definition sip.h:360
sip_request_s::rq_common
sip_common_t rq_common[1]
Common fragment info.
Definition sip.h:358
sip_request_s::rq_next
sip_error_t * rq_next
Link to next (dummy).
Definition sip.h:359
sip_request_s::rq_method_name
char const * rq_method_name
Method name.
Definition sip.h:361
sip_request_s::rq_version
char const * rq_version
Protocol version.
Definition sip.h:363
sip_request_s::rq_url
url_t rq_url[1]
RequestURI.
Definition sip.h:362
url_t

## Function Documentation

## sip_is_request()

int sip_is_request | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_request_t.

Check if the header class is an instance of request line object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header request
  0 | (false) otherwise

## sip_request_copy()

sip_request_t * sip_request_copy | ( | su_home_t * | home,
|  | sip_request_t const * | hdr )

inline

Copy a list of request line header structures sip_request_t.

The function sip_request_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  request = sip_request_copy(home, sip->sip_request);
  sip_request_copy
  sip_request_t * sip_request_copy(su_home_t *home, sip_request_t const *hdr))
  Copy a list of request line header structures sip_request_t.
  Definition sip_protos.h:278

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_request_create()

sip_request_t * sip_request_create | ( | su_home_t * | home,
|  | sip_method_t | method,
|  | char const * | name,
|  | url_string_t const * | uri,
|  | char const * | version )

Create a request line object.

Create a request line object.

Create a request line object with method enum method, method name name, request URI uri, and protocol version version. The memory for the header object is allocated from the memory home home.

Parameters

  home | memory home used to allocate sip_request_t object
  method | method enum
  name | method name (required if method is not well-known)
  uri | request URI
  version | version string (defaults to "SIP/2.0" if NULL)

Example
  The following code fragment creates an OPTIONS request object:
  sip_request_t *rq;
  rq = sip_request_create(home, SIP_METHOD_OPTIONS, requestURI, NULL);
  sip_request_create
  sip_request_t * sip_request_create(su_home_t *home, sip_method_t method, const char *name, url_string_t const *url, char const *version)
  Create a request line object.
  Definition sip_basic.c:208

Note
  If you provide an non-NULL version string, it is not copied. The version string MUST remain constant.

## sip_request_dup()

sip_request_t * sip_request_dup | ( | su_home_t * | home,
|  | sip_request_t const * | hdr )

inline

Duplicate a list of request line header structures sip_request_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  request = sip_request_dup(home, sip->sip_request);
  sip_request_dup
  sip_request_t * sip_request_dup(su_home_t *home, sip_request_t const *hdr))
  Duplicate a list of request line header structures sip_request_t.
  Definition sip_protos.h:235

Returns
  A pointer to the newly duplicated sip_request_t header structure, or NULL upon an error.

## sip_request_format()

sip_request_t * sip_request_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a request line from formatting result.

Make a new sip_request_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_request_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_request_init()

sip_request_t * sip_request_init | ( | sip_request_t | x[1] | ) |

inline

Initialize a structure sip_request_t.

An sip_request_t structure for request line can be initialized with the sip_request_init() function/macro. For instance,

sip_request_t sip_request;
sip_request_init(&sip_request);
sip_request_init
sip_request_t * sip_request_init(sip_request_t x[1])
Initialize a structure sip_request_t.
Definition sip_protos.h:166

## sip_request_make()

sip_request_t * sip_request_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a request line structure sip_request_t.

The function sip_request_make() makes a new sip_request_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_request_t header structure, or NULL upon an error.

## Variable Documentation

## sip_request_class

msg_hclass_t sip_request_class[]

extern

Header class for request line.

The header class sip_request_class defines how a SIP request line is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_request_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.